from libutilitaspy.aspects.core import *

class MyAspect1(Aspect):
    classes = 'SomeClass[0-9]+'    # a regular expression
    methods = 'some_method'        # a regular expression
    def before(self, klass, method, obj, *args, **kwargs):
        print 'MyAspect1.before'
    def after(self, klass, method, obj, retval, exc_type, exc_val, traceback):
        print 'MyAspect1.after'



class MyAspect2(Aspect):
    classes = 'SomeClass[0-9]+'    # a regular expression
    methods = '.*_method'        # a regular expression
    def before(self, klass, method, obj, *args, **kwargs):
        print 'MyAspect2.before'
    def after(self, klass, method, obj, retval, exc_type, exc_val, traceback):
        print 'MyAspect2.after'



MyMetaClass = WeaverMetaClassFactory(MyAspect1(), MyAspect2())   

class SomeClass1(object):
    
    __metaclass__ = MyMetaClass
    
    def some_method(self):
        print "SomeClass1.some_method"

    def another_method(self):
        print "SomeClass1.another_method"


obj1 = SomeClass1()
print
obj1.some_method()
print
obj1.another_method()
